package com.allinpay.yst2.demo.tx;

import com.allinpay.yst2.demo.util.DemoSM4Utils;
import com.allinpay.yst2.demo.util.TxUtils;
import com.allinpay.yst2.demo.vo.BizParameter;
import com.allinpay.yst2.demo.vo.TxResponse;

import java.util.HashMap;
import java.util.Map;

/**
 * 测试demo
 * 企业会员实名开户
 * @author gejunqing
 * @version 1.0
 * @date 2024/1/11
 */
public class Member1020Demo extends TxDemo
{
    public static void main(String[] args) throws Exception
    {
        // 组装参数
        BizParameter bizParameter = new BizParameter();
        bizParameter.addParam("reqTraceNum", TxUtils.genReqTraceNum());
        bizParameter.addParam("signNum", "busi2");
        bizParameter.addParam("memberRole", "收款方");
        bizParameter.addParam("enterpriseNature", "2");  // 1企业，2个体户，3事业单位
        bizParameter.addParam("notifyUrl", "http://test.allinpay.com/open/testNotify");
        Map<String, Object> enterpriseBaseInfo = new HashMap<>(); //企业基本信息
        enterpriseBaseInfo.put("enterpriseName", "餐饮店");
        enterpriseBaseInfo.put("enterpriseAdress", "上海滩");
        enterpriseBaseInfo.put("unifiedSocialCredit", "");
        enterpriseBaseInfo.put("busLicenseValidate", "9999-12-31");
        enterpriseBaseInfo.put("legalPersonName", "王三华");
        enterpriseBaseInfo.put("legalPersonCerType", "1");
        enterpriseBaseInfo.put("legalPersonCerNum", DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(),""));
        enterpriseBaseInfo.put("idValidateStart", "2023-12-31");
        enterpriseBaseInfo.put("idValidateEnd", "9999-12-31");
        enterpriseBaseInfo.put("legalPersonPhone", "");
        bizParameter.addMapParam("enterpriseBaseInfo", enterpriseBaseInfo);
        Map<String, Object> bankAcctDetail = new HashMap<>();  //银行账户信息
        bankAcctDetail.put("acctAttr", "1"); // 0对私，1对公
        bankAcctDetail.put("acctNum", DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(), "123426789159100"));
        bankAcctDetail.put("bankReservePhone", "12312341234");//银行预留手机，对私必填
        bankAcctDetail.put("openBankNo", "01020000");//银行代码，对公必填
        bankAcctDetail.put("openBankBranchName", "中国工商银行上海滩分行");
        bankAcctDetail.put("payBankNumber", "123456789123");//支行行号
        bankAcctDetail.put("openBankProvince", "上海市");
        bankAcctDetail.put("openBankCity", "上海市");
        bizParameter.addMapParam("bankAcctDetail", bankAcctDetail);

        // 发送请求
        TxClient txClient = new TxClient(demoConfig);
        TxResponse txResponse = txClient.sendRequest("1020", bizParameter, demoConfig.getMemberUrl());
        // 打印响应结果
        logger.info(txResponse.getBizData());
    }
}
