package com.allinpay.yst2.demo.tx;

import com.allinpay.yst2.demo.util.DemoSM4Utils;
import com.allinpay.yst2.demo.util.TxUtils;
import com.allinpay.yst2.demo.vo.BizParameter;
import com.allinpay.yst2.demo.vo.TxResponse;

import java.util.HashMap;
import java.util.Map;

/**
 * 企业支付账户开户接口测试
 *
 * @author gejunqing
 * @version 1.0
 * @date 2024/1/11
 */
public class Member1025Demo extends TxDemo
{
    public static void main(String[] args) throws Exception
    {
        // 组装参数
        BizParameter bizParameter = new BizParameter();
        bizParameter.addParam("reqTraceNum", TxUtils.genReqTraceNum());
        bizParameter.addParam("signNum", "Tn470001");//#yunBizUserId_B2C#
        bizParameter.addParam("memberRole", "收款方");
        bizParameter.addParam("enterpriseNature", "2");//1-企业  2-个体工商户 3-事业单位
        bizParameter.addParam("notifyUrl", "http://test.allinpay.com/open/testNotify");

        //企业基本信息
        Map<String, Object> enterpriseBaseInfo = new HashMap<>();
        enterpriseBaseInfo.put("busLicenseValidate", "2028-12-31");
        enterpriseBaseInfo.put("idValidateStart", "2021-12-31");
        enterpriseBaseInfo.put("idValidateEnd", "9999-12-31");
        enterpriseBaseInfo.put("busiScope","水产之类");  //经营内容     //必填，
        enterpriseBaseInfo.put("addressCode", "110101");   //地区码
      /////已实名会员可不填
        enterpriseBaseInfo.put("enterpriseName", "竹溪县子怡鞋店");

        enterpriseBaseInfo.put("enterpriseAdress", "金沪路55号");
        enterpriseBaseInfo.put("unifiedSocialCredit", "92420324MA4D68J28J");//92420324MA4D68J28J
        enterpriseBaseInfo.put("legalPersonName", "王三华");
        enterpriseBaseInfo.put("legalPersonCerType", "1");  //仅支持1：身份证，51370119380325580x
        enterpriseBaseInfo.put("legalPersonCerNum",DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(), ""));
        enterpriseBaseInfo.put("legalPersonPhone", "");//*/
        bizParameter.addMapParam("enterpriseBaseInfo", enterpriseBaseInfo);

        //受益人基本信息
        Map<String,Object> legaAndBeneficiaryInfo = new HashMap<>();
        //法人国籍
        legaAndBeneficiaryInfo.put("legalCountry","中国");
        //法人性别  1：男  2：女
        legaAndBeneficiaryInfo.put("legalSex","1");
        //法人职业
        legaAndBeneficiaryInfo.put("legalCareer","1");
        //法人住址
        legaAndBeneficiaryInfo.put("legalAddress","凤岗村");
        //商户类型   00个体户  01公司不含国企  02 合伙企业  03个人独资企业   04国企
        legaAndBeneficiaryInfo.put("merchantType","01");
        //受益所有人判定标准
        legaAndBeneficiaryInfo.put("beneficiaryJudgmentCriteria","1");
        //证明材料    当“商户类型”字段选择“2-公司（不包含国有企业）”时,则“证明材料”字段不可上送“64”；
        legaAndBeneficiaryInfo.put("beneficiaryJudgmentFile","61");
        //法人是否受益人 0 是 1否
        legaAndBeneficiaryInfo.put("legalIsBeneficiary","1");
        //法人是否为股东控制人  0 是 1否
        legaAndBeneficiaryInfo.put("legalIsShareholder","1");
        //受益人证件类型
        legaAndBeneficiaryInfo.put("beneficiaryCerType","1");
        //受益人姓名
        legaAndBeneficiaryInfo.put("beneficiaryName","");
        //受益人证件号码
        legaAndBeneficiaryInfo.put("beneficiaryCerNum",DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(), ""));
        //受益人证件证件有效期
        legaAndBeneficiaryInfo.put("beneficiaryCerValidate","9999-12-31");
        //是否高管  0：否  1：是
        legaAndBeneficiaryInfo.put("isSeniorManagement","1");
        //受益人住址
        legaAndBeneficiaryInfo.put("beneficiaryAddress","凤岗村");
        //控股股东姓名
        legaAndBeneficiaryInfo.put("shareholderName","");
        //控股股东证件号码
        legaAndBeneficiaryInfo.put("shareholderCerNum",DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(), ""));
        //控股股东证件有效期
        legaAndBeneficiaryInfo.put("shareholderCerValidate","2099-12-31");
        bizParameter.addMapParam("legaAndBeneficiaryInfo", legaAndBeneficiaryInfo);

        //银行账户信息
        Map<String, Object> bankAcctDetail = new HashMap<>();
        //账户类型 0对私（银行账户名称默认为法人姓名）1对公（银行账户名称默认为企业名称）
        bankAcctDetail.put("acctAttr", "1");
        //账号  6210261104003846219，12345678900
        bankAcctDetail.put("acctNum",DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(), "1234567890"));

        //银行预留手机 账户类型=0-对私，则必填
       // bankAcctDetail.put("bankReservePhone", "");
        //开户银行代码 对公：必须上送， 对私：无需上送，系统自动根据卡BIN识别银行
        bankAcctDetail.put("openBankNo", "01040000");
        //开户行支行名称
        bankAcctDetail.put("openBankBranchName", "中国银行上海滩分行");
        //支付行号，12位数字
        bankAcctDetail.put("payBankNumber", "100504100265");
        bankAcctDetail.put("openBankProvince", "上海市");
        bankAcctDetail.put("openBankCity", "上海市");//*/
        bizParameter.addMapParam("bankAcctDetail", bankAcctDetail);

        //开户附件材料
        Map<String,Object> attachments = new HashMap<>();
        //统一信用证照片
        attachments.put("unifiedSocialCreditPhoto","3320240402211775150284935442433");
        //法人国徽面
        attachments.put("legalNationalEmblemPhoto","3320240402211775150589207031809");
        //法人人像面
        attachments.put("legalFacePhoto","3320240402211775150493119721473");
        //结算账户照
        attachments.put("settleAcctPhoto","3320240402211775150181608763394");
        //经营门头照片
        attachments.put("businessDoorHeadPhoto","3320240402211775150181608763394");
        //经营内景照片
        attachments.put("businessInteriorPhoto","3320240402211775150181608763394");
        //客户经理与门头照
        attachments.put("accountManagerWithDoorPhoto","3320240402211775150181608763394");
        //客户经理手持身份证照片
        attachments.put("accountManagerHoldingIdCardPhoto","3320240402211775150181608763394");
        //受益所有人证明材料
        attachments.put("beneficiaryFile","3320240402211775150181608763394");
        bizParameter.addMapParam("attachments", attachments);


        // 发送请求
        TxClient txClient = new TxClient(demoConfig);
        TxResponse txResponse = txClient.sendRequest("1025", bizParameter, demoConfig.getMemberUrl());
        // 打印响应结果
        logger.info(txResponse.getBizData());
    }
}
