package com.allinpay.yst2.demo.tx;

import com.allinpay.yst2.demo.util.DemoSM4Utils;
import com.allinpay.yst2.demo.util.TxUtils;
import com.allinpay.yst2.demo.vo.BizParameter;
import com.allinpay.yst2.demo.vo.TxResponse;

import java.util.HashMap;
import java.util.Map;

/**
 * 会员绑定手机号测试demo
 *
 * @author gejunqing
 * @version 1.0
 * @date 2024/1/11
 */
public class Member1030Demo extends TxDemo
{
    public static void main(String[] args) throws Exception
    {
        // 组装参数
        BizParameter bizParameter = new BizParameter();
        bizParameter.addParam("reqTraceNum", TxUtils.genReqTraceNum());
        bizParameter.addParam("signNum", "Tc40200008");
        bizParameter.addParam("phone", "");
        bizParameter.addParam("phoneType", "1");  //2-被授权人，1-法人
        Map<String, Object> map = new HashMap<>();
        map.put("authPerCerType", "1");
        map.put("authPerCerNum", DemoSM4Utils.encryptEcb(demoConfig.getSecretKey(), ""));
        map.put("authPerName", "");
   //     bizParameter.addMapParam("authPerInfo", map);   //*/

        // 发送请求
        TxClient txClient = new TxClient(demoConfig);
        TxResponse txResponse = txClient.sendRequest("1030", bizParameter, demoConfig.getMemberUrl());
        // 打印响应结果
        logger.info(txResponse.getBizData());
    }
}
