package com.allinpay.yst2.demo.tx;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSON;
import com.allinpay.yst2.demo.util.TxUtils;
import com.allinpay.yst2.demo.vo.BizParameter;
import com.allinpay.yst2.demo.vo.TxResponse;

/**
 * 【退款申请】
 *
 * @author gejunqing
 * @version 1.0
 * @date 2024/1/11
 */
public class Tx2294Demo extends TxDemo
{
    public static void main(String[] args) throws Exception
    {
    	//分账退款列表
        List<Map<String, Object>> sepDetail = new ArrayList<>();
        Map<String, Object> sepMap1 = new HashMap<>();
        sepMap1.put("signNum", "9665wxl202400004");//分账收款人会员编号
        sepMap1.put("amount", 1);
        //sepMap1.put("remark", "remark");
        sepDetail.add(sepMap1);
        Map<String, Object> sepMap2 = new HashMap<>();
        sepMap2.put("signNum", "9665wxl202400005");
        sepMap2.put("amount", 1);
        sepDetail.add(sepMap2);
    	
    	//订单退款列表
    	List<Map<String, Object>> refundDetail = new ArrayList<>();
        Map<String, Object> rdMap1 = new HashMap<>();
        rdMap1.put("signNum", "9665wxl202400008");
        rdMap1.put("orderAmount", 4);
//        rdMap1.put("acctType", "1");//未担保确认，不上送。已担保确认，上送 1：簿记账户
//        rdMap1.put("couponAmount", 1);
//        rdMap1.put("sepDetail", JSON.toJSONString(sepDetail));
        refundDetail.add(rdMap1);
        Map<String, Object> rdMap2 = new HashMap<>();
        rdMap2.put("signNum", "9665wxl202400006");
        rdMap2.put("orderAmount", 2);
//        rdMap2.put("acctType", "1");
        
//        refundDetail.add(rdMap2);
        
        
    	
    	
    	// 组装参数
        BizParameter bizParameter = new BizParameter();
        bizParameter.addParam("reqTraceNum", "wxl"+TxUtils.genReqTraceNum());
        bizParameter.addParam("orgRespTraceNum", "20240228155218208501446291");
        bizParameter.addParam("orderAmount", 4);
        bizParameter.addParam("promotionAmount", 1);//营销退款金额
        bizParameter.addListParam("refundDetail", refundDetail);//订单退款列表
       // bizParameter.addParam("isFundAllocation", "0");//是否需要调拨资金  0：否、1：是
        bizParameter.addParam("respUrl", "http://test.allinpay.com/open/testNotify");
       // bizParameter.addParam("chnlDiscAmt", "{\"orderInfo\":\"abcdefghiii\"}");//优惠信息：银联云闪付单品
        // bizParameter.addParam("extendParams", "{\"extend\":\"abcdefghiii\"}");
        
        
        
        // 发送请求
        TxClient txClient = new TxClient(demoConfig);
        TxResponse txResponse = txClient.sendRequest("2294", bizParameter);
        // 打印响应结果
        logger.info(txResponse.getBizData());
    }
}
